VTK: vtkStaticCellLinks Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkStaticCellLinks Class Reference

object represents upward pointers from points to list of cells using each point More...

`#include <vtkStaticCellLinks.h>`

Inheritance diagram for vtkStaticCellLinks:
[legend]
Collaboration diagram for vtkStaticCellLinks:
[legend]

## Public Member Functions
void | BuildLinks () override
| Build the link list array from the input dataset. More...
vtkIdType | GetNumberOfCells (vtkIdType ptId)
| Get the number of cells using the point specified by ptId. More...
vtkIdType | GetNcells (vtkIdType ptId)
| Get the number of cells using the point specified by ptId. More...
vtkIdType * | GetCells (vtkIdType ptId)
| Return a list of cell ids using the specified point. More...
void | Initialize () override
| Make sure any previously created links are cleaned up. More...
void | Squeeze () override
| Reclaim any unused memory. More...
void | Reset () override
| Reset to a state of no entries without freeing the memory. More...
unsigned long | GetActualMemorySize () override
| Return the memory in kibibytes (1024 bytes) consumed by this cell links array. More...
void | DeepCopy (vtkAbstractCellLinks *src) override
| Standard DeepCopy method. More...
void | SelectCells (vtkIdType minMaxDegree[2], unsigned char *cellSelection) override
| Select all cells with a point degree in the range [minDegree,maxDegree). More...
Public Member Functions inherited from vtkAbstractCellLinks
void | BuildLinks (vtkDataSet *data)
| Set the input dataset and build the link list array. More...
virtual int | GetType ()
| Return the type of locator (see enum above). More...
virtual void | SetDataSet (vtkDataSet *)
| Set/Get the points/cells defining this dataset. More...
virtual vtkDataSet * | GetDataSet ()
| Set/Get the points/cells defining this dataset. More...
virtual void | SetSequentialProcessing (bool)
| Force sequential processing (i.e. More...
virtual bool | GetSequentialProcessing ()
| Force sequential processing (i.e. More...
virtual void | SequentialProcessingOn ()
| Force sequential processing (i.e. More...
virtual void | SequentialProcessingOff ()
| Force sequential processing (i.e. More...
virtual vtkMTimeType | GetBuildTime ()
| Return the time of the last data structure build. More...
bool | UsesGarbageCollector () const override
| Handle the dataset <-> Links loop. More...
vtkAbstractCellLinks * | NewInstance () const
| Standard type and print methods. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Protected Member Functions
| vtkStaticCellLinks ()
| ~vtkStaticCellLinks () override
Protected Member Functions inherited from vtkAbstractCellLinks
| vtkAbstractCellLinks ()
| ~vtkAbstractCellLinks () override
void | ReportReferences (vtkGarbageCollector *) override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkStaticCellLinksTemplate< vtkIdType > * | Impl
Protected Attributes inherited from vtkAbstractCellLinks
vtkDataSet * | DataSet
bool | SequentialProcessing
int | Type
vtkTimeStamp | BuildTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkAbstractCellLinks | Superclass
| Standard methods for instantiation, type manipulation and printing. More...
static vtkStaticCellLinks * | New ()
| Standard methods for instantiation, type manipulation and printing. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instantiation, type manipulation and printing. More...
static vtkStaticCellLinks * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instantiation, type manipulation and printing. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instantiation, type manipulation and printing. More...
vtkStaticCellLinks * | NewInstance () const
| Standard methods for instantiation, type manipulation and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instantiation, type manipulation and printing. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instantiation, type manipulation and printing. More...

## Additional Inherited Members
Public Types inherited from vtkAbstractCellLinks
enum | CellLinksTypes { LINKS_NOT_DEFINED = 0 , CELL_LINKS = 1 , STATIC_CELL_LINKS_USHORT = 2 , STATIC_CELL_LINKS_UINT = 3 , STATIC_CELL_LINKS_IDTYPE = 4 , STATIC_CELL_LINKS_SPECIALIZED = 5 }
typedef vtkObject | Superclass
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkAbstractCellLinks
static int | ComputeType (vtkIdType maxPtId, vtkIdType maxCellId, vtkCellArray *ca)
| Based on the input (i.e., number of points, number of cells, and length of connectivity array) this helper method returns the integral type to use when instantiating cell link-related classes in order to properly represent the data. More...
static int | ComputeType (vtkIdType maxPtId, vtkIdType maxCellId, vtkIdType connectivitySize)
static vtkTypeBool | IsTypeOf (const char *type)
| Standard type and print methods. More...
static vtkAbstractCellLinks * | SafeDownCast (vtkObjectBase *o)
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

object represents upward pointers from points to list of cells using each point

vtkStaticCellLinks is a supplemental object to vtkCellArray and vtkCellTypes, enabling access from points to the cells using the points. vtkStaticCellLinks is an array of links, each link represents a list of cell ids using a particular point. The information provided by this object can be used to determine cell neighbors and construct other local topological information. This class is a faster implementation of vtkCellLinks. However, it cannot be incrementally constructed; it is meant to be constructed once (statically) and must be rebuilt if the cells change.

Warning
  This is a drop-in replacement for vtkCellLinks using static link construction. It uses the templated vtkStaticCellLinksTemplate class, instantiating vtkStaticCellLinksTemplate with a vtkIdType template parameter. Note that for best performance, the vtkStaticCellLinksTemplate class may be used directly, instantiating it with the appropriate id type. This class is also wrappable and can be used from an interpreted language such as Python.

See also
  vtkCellLinks vtkStaticCellLinksTemplate

Tests:
  vtkStaticCellLinks (Tests)

Definition at line 45 of file vtkStaticCellLinks.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractCellLinks vtkStaticCellLinks::Superclass

Standard methods for instantiation, type manipulation and printing.

Definition at line 53 of file vtkStaticCellLinks.h.

## Constructor & Destructor Documentation

## ◆ vtkStaticCellLinks()

vtkStaticCellLinks::vtkStaticCellLinks | ( |  | ) |
| protected

## ◆ ~vtkStaticCellLinks()

vtkStaticCellLinks::~vtkStaticCellLinks | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkStaticCellLinks* vtkStaticCellLinks::New | ( |  | ) |
| static

Standard methods for instantiation, type manipulation and printing.

## ◆ IsTypeOf()

static vtkTypeBool vtkStaticCellLinks::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instantiation, type manipulation and printing.

## ◆ IsA()

virtual vtkTypeBool vtkStaticCellLinks::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instantiation, type manipulation and printing.

Reimplemented from vtkAbstractCellLinks.

## ◆ SafeDownCast()

static vtkStaticCellLinks* vtkStaticCellLinks::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instantiation, type manipulation and printing.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkStaticCellLinks::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instantiation, type manipulation and printing.

Reimplemented from vtkAbstractCellLinks.

## ◆ NewInstance()

vtkStaticCellLinks* vtkStaticCellLinks::NewInstance | ( |  | ) | const

Standard methods for instantiation, type manipulation and printing.

## ◆ PrintSelf()

void vtkStaticCellLinks::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instantiation, type manipulation and printing.

Reimplemented from vtkAbstractCellLinks.

## ◆ BuildLinks()

void vtkStaticCellLinks::BuildLinks | ( |  | ) |
| overridevirtual

Build the link list array from the input dataset.

Implements vtkAbstractCellLinks.

## ◆ GetNumberOfCells()

vtkIdType vtkStaticCellLinks::GetNumberOfCells | ( | vtkIdType | ptId | ) |
| inline

Get the number of cells using the point specified by ptId.

Definition at line 65 of file vtkStaticCellLinks.h.

## ◆ GetNcells()

vtkIdType vtkStaticCellLinks::GetNcells | ( | vtkIdType | ptId | ) |
| inline

Get the number of cells using the point specified by ptId.

This is an alias for GetNumberOfCells(); consistent with the vtkCellLinks API.

Definition at line 71 of file vtkStaticCellLinks.h.

## ◆ GetCells()

vtkIdType* vtkStaticCellLinks::GetCells | ( | vtkIdType | ptId | ) |
| inline

Return a list of cell ids using the specified point.

Definition at line 76 of file vtkStaticCellLinks.h.

## ◆ SelectCells()

void vtkStaticCellLinks::SelectCells | ( | vtkIdType | minMaxDegree[2],
|  | unsigned char * | cellSelection
| ) |  |
| inlineoverridevirtual

Select all cells with a point degree in the range [minDegree,maxDegree).

The degree is the number of cells using a point. The selection is indicated through the provided unsigned char array, with a non-zero value indicates selection. The memory allocated for cellSelection must be the maximum cell id referenced in the links.

Implements vtkAbstractCellLinks.

Definition at line 86 of file vtkStaticCellLinks.h.

## ◆ Initialize()

void vtkStaticCellLinks::Initialize | ( |  | ) |
| inlineoverridevirtual

Make sure any previously created links are cleaned up.

Implements vtkAbstractCellLinks.

Definition at line 95 of file vtkStaticCellLinks.h.

## ◆ Squeeze()

void vtkStaticCellLinks::Squeeze | ( |  | ) |
| inlineoverridevirtual

Reclaim any unused memory.

Implements vtkAbstractCellLinks.

Definition at line 104 of file vtkStaticCellLinks.h.

## ◆ Reset()

void vtkStaticCellLinks::Reset | ( |  | ) |
| inlineoverridevirtual

Reset to a state of no entries without freeing the memory.

Implements vtkAbstractCellLinks.

Definition at line 109 of file vtkStaticCellLinks.h.

## ◆ GetActualMemorySize()

unsigned long vtkStaticCellLinks::GetActualMemorySize | ( |  | ) |
| inlineoverridevirtual

Return the memory in kibibytes (1024 bytes) consumed by this cell links array.

Used to support streaming and reading/writing data. The value returned is guaranteed to be greater than or equal to the memory required to actually represent the data represented by this object. The information returned is valid only after the pipeline has been updated.

Implements vtkAbstractCellLinks.

Definition at line 119 of file vtkStaticCellLinks.h.

## ◆ DeepCopy()

void vtkStaticCellLinks::DeepCopy | ( | vtkAbstractCellLinks * | src | ) |
| overridevirtual

Standard DeepCopy method.

Since this object contains no reference to other objects, there is no ShallowCopy.

Implements vtkAbstractCellLinks.

## Member Data Documentation

## ◆ Impl

vtkStaticCellLinksTemplate<vtkIdType>* vtkStaticCellLinks::Impl
| protected

Definition at line 131 of file vtkStaticCellLinks.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkStaticCellLinks.h